#include "widgets/PreviewNextPageWidget.h"
#include "nPresenter.h"

PreviewNextPageWidget::PreviewNextPageWidget(QWidget *parent) :
    ViewportWidget(parent)
{

}

const QImage PreviewNextPageWidget::slide()
{
	return QImage();
}

Document::Viewports PreviewNextPageWidget::viewport()
{
	return Document::PresentationOneViewport;
}

//QSize PreviewNextPageWidget::sizeHint() const
//{
//	return QWidget::sizeHint();
//}

void PreviewNextPageWidget::paintEvent(QPaintEvent *event)
{
	event->accept();

	QPainter painter;
	painter.begin(this);
	
	/* Enable antialiasing. It looks nice. :) */
	painter.setRenderHint(QPainter::Antialiasing, true);
	
	/* don't draw more than event requests */
	painter.setClipRect(event->rect());
	painter.setClipping(true);

	
	/* center of the widget */
	QPoint center = this->rect().center();

	/* set the target rect to viewportSize() and center it */
	QRect targetRect;
	targetRect.setSize(this->viewportSize());
	targetRect.moveCenter(center);
	targetRect.moveTop(5);
	
	/* draw the the slide */
	this->drawSlide(painter, targetRect, _viewportCache, 1.0, 10.0);
	
	painter.end();
}


void PreviewNextPageWidget::requestPage(int pageNum)
{
	pageNum++;
	ViewportWidget::requestPage(pageNum);
}

void PreviewNextPageWidget::viewportIsReady(Viewports viewport, int page, QSize size)
{
	if(viewport == this->viewport() && page == nPresenter::currentPage()+1 && size == this->viewportSize())
	{
		_viewportCache = nPresenter::document().viewport(viewport, page, size);
		this->update();
	}
}
